Bug 142745 - [EMF] Hang on FillRgn EMR
Summary: [EMF] Hang on FillRgn EMR
Status: VERIFIED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: graphics stack (show other bugs)
Version:
(earliest affected)
7.2.0.0 alpha1+
Hardware: All All
: medium normal
Assignee: Bartosz
URL:
Whiteboard: target:7.2.0 target:7.1.5
Keywords: bibisected, bisected, regression
Depends on:
Blocks: EMF-WMF
  Show dependency treegraph
 
Reported: 2021-06-09 18:38 UTC by Valek Filippov
Modified: 2021-06-11 09:06 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments
EMF sample (24.18 KB, image/x-emf)
2021-06-09 18:38 UTC, Valek Filippov
Details
How it should look like (5.49 KB, image/png)
2021-06-09 18:39 UTC, Valek Filippov
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Valek Filippov 2021-06-09 18:38:02 UTC
Description:
LO Draw freezes on attempt to insert attached EMF file.

Steps to Reproduce:
Open attached EMF file.

Actual Results:
LO Draw shows nothing and eventually freezes.

Expected Results:
It should show "PCT" logo.


Reproducible: Always


User Profile Reset: No



Additional Info:
The sample is a minified version from AOO bz#125725
Comment 1 Valek Filippov 2021-06-09 18:38:41 UTC
Created attachment 172747 [details]
EMF sample
Comment 2 Valek Filippov 2021-06-09 18:39:42 UTC
Created attachment 172748 [details]
How it should look like
Comment 3 Xisco Faulí 2021-06-09 20:38:40 UTC
The hang per se is a regression from

https://cgit.freedesktop.org/libreoffice/core/commit/?id=5d4d8278b7fd2a555d6c9678d37877853562bd85

author	Bartosz Kosiorek <gang65@poczta.onet.pl>	2021-03-31 17:50:59 +0200
committer	Bartosz Kosiorek <gang65@poczta.onet.pl>	2021-03-31 20:08:37 +0200
commit	5d4d8278b7fd2a555d6c9678d37877853562bd85 (patch)
tree	e72a000fb79b324618cc3020f91f254e268c5158
parent	1477401805e2a88cddb1df259456359398fa2b7d (diff)
tdf#55058 tdf#141394 EMF FILLRGN record is not displayed correctly

Bisected with: bibisect-linux64-7.2

Adding Cc: to Bartosz Kosiorek
Comment 4 Commit Notification 2021-06-10 16:50:39 UTC
Bartosz Kosiorek committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/363b98b268f317e7f2f9af392085856b938fb5f9

EMF tdf#142745 Improve performance of FILLRGN, PAINTRGN, EXTSELECTCLIPRGN

It will be available in 7.2.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 5 Xisco Faulí 2021-06-11 09:05:20 UTC
No longer hangs in

Version: 7.2.0.0.alpha1+ / LibreOffice Community
Build ID: b0712101351b084e5073d41052a0abc4f36f4789
CPU threads: 4; OS: Linux 5.7; UI render: default; VCL: gtk3
Locale: en-US (en_US.UTF-8); UI: en-US
Calc: threaded

@Bartosz, thanks for fixing this issue!! I believe other areas will benefit from this improvement too
Comment 6 Commit Notification 2021-06-11 09:06:43 UTC
Bartosz Kosiorek committed a patch related to this issue.
It has been pushed to "libreoffice-7-1":

https://git.libreoffice.org/core/commit/b20b7339f1786d27fec3787f3567c234757d3959

EMF tdf#142745 Improve performance of FILLRGN, PAINTRGN, EXTSELECTCLIPRGN

It will be available in 7.1.5.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.